/* ------------------------------------------------------------------------ */
/*   bodef.h	Definions of the boltzmann -propagation rule classes etc.         */
/* ------------------------------------------------------------------------ */

/* ----- define literals to reference rules and parameters in arrays ------ */

/* net rules */
#define		NET_R_learn_one		0
#define		NET_R_recall		1
#define		NET_R_weight_upd	2
#define		NET_R_plus_minus_test	3
#define		NET_R_phase_plus    	4		
#define		NET_R_phase_minus	5
#define		NET_R_collect_plus	6	
#define		NET_R_collect_minus 	7
#define		NET_R_clamp_output	8
#define		NET_R_test_iteration    9
#define		NET_R_test_annealing	10
#define		NET_R_temp_reduce   	11
#define		NET_R_temp_init   	12
#define		NET_R_plus	13
#define		NET_R_minus 14
#define		NET_R_unclamped 15
#define		NET_R_weight_upd_plus 16
#define		NET_R_weight_upd_minus 17
			

/* net parameters */
#define		NET_P_temperature	0
#define		NET_P_temp_start	1
#define		NET_P_temp_equi		2
#define		NET_P_temp_step		3	
#define		NET_P_learn_rate	4
#define		NET_P_iter_equi		5
#define		NET_P_iteration		6
#define		NET_P_pplus_pminus	7
#define		NET_P_input_control	8	
#define		NET_P_target_control	9
#define		NET_P_current_pat	10
#define		NET_P_pattern_nbe	11

/* layer rules */
#define		LAY_R_acc_upd		0
#define		LAY_R_state_shift	1
#define		LAY_R_weight_upd	2
#define		LAY_R_adjust_pplus	3
#define		LAY_R_adjust_pminus	4
#define		LAY_R_hid_acc_upd 	5
#define		LAY_R_hid_state_shift	6
#define		LAY_R_weight_upd_plus 7
#define		LAY_R_weight_upd_minus 8


/* neuron rules */
#define		NEU_R_acc_upd		0
#define		NEU_R_state_shift	1
#define		NEU_R_weight_upd	2
#define		NEU_R_adjust_pplus	3
#define		NEU_R_adjust_pminus	4
#define		NEU_R_weight_upd_plus 5
#define		NEU_R_weight_upd_minus 6

/* synapses parameters */
#define		SYN_P_pplus		0
#define		SYN_P_pminus		1

/* ------------------------------------------------------------------------ */
